Clipped Smart Object

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files
- Examples

Data Structures | Typedefs | Functions
Clipped Smart Object
Evas » Smart Object Functions

Clipped smart object is a base to construct other smart objects based on the concept of having an internal clipper that is applied to all children objects. More...

## Data Structures
struct | _Evas_Object_Smart_Clipped_Data

## Typedefs
typedef struct _Evas_Object_Smart_Clipped_Data | Evas_Object_Smart_Clipped_Data
| Every subclass should provide this at the beginning of their own data set with evas_object_smart_data_set().

## Functions
void | evas_object_smart_clipped_smart_set (Evas_Smart_Class *sc)
| Set a given smart class' callbacks so it implements the clipped smart object"'s interface. More...
const Evas_Smart_Class * | evas_object_smart_clipped_class_get (void)
| Get a pointer to the clipped smart object's class, to use for proper inheritance. More...
Evas_Object * | evas_object_smart_clipped_clipper_get (const Evas_Object *obj)
| Get the clipper object for the given clipped smart object. More...

## Detailed Description

Clipped smart object is a base to construct other smart objects based on the concept of having an internal clipper that is applied to all children objects.

This clipper will control the visibility, clipping and color of sibling objects (remember that the clipping is recursive, and clipper color modulates the color of its clippees). By default, this base will also move children relatively to the parent, and delete them when parent is deleted. In other words, it is the base for simple object grouping.

See some examples of this group of functions.

See also
  evas_object_smart_clipped_smart_set()

## Function Documentation

void evas_object_smart_clipped_smart_set | ( | Evas_Smart_Class * | sc | ) |

Set a given smart class' callbacks so it implements the clipped smart object"'s interface.

Parameters

  sc | The smart class handle to operate on

This call will assign all the required methods of the `sc` Evas_Smart_Class instance to the implementations set for clipped smart objects. If one wants to "subclass" it, call this function and then override desired values. If one wants to call any original method, save it somewhere. Example:

1 static Evas_Smart_Class parent_sc = EVAS_SMART_CLASS_INIT_NULL;
2
3 static void my_class_smart_add(Evas_Object *o)
4 {
5 parent_sc.add(o);
6 evas_object_color_set(evas_object_smart_clipped_clipper_get(o),
7 255, 0, 0, 255);
8 }
9
10 Evas_Smart_Class *my_class_new(void)
11 {
12 static Evas_Smart_Class sc = EVAS_SMART_CLASS_INIT_NAME_VERSION("MyClass");
13 if (!parent_sc.name)
14 {
15 evas_object_smart_clipped_smart_set(&sc);
16 parent_sc = sc;
17 sc.add = my_class_smart_add;
18 }
19 return &sc;
20 }

Default behavior for each of Evas_Smart_Class functions on a clipped smart object are:

- `add:` creates a hidden clipper with "infinite" size, to clip any incoming members;
- `del:` delete all children objects;
- `move:` move all objects relative relatively;
- `resize:` not defined;
- `show:` if there are children objects, show clipper;
- `hide:` hides clipper;
- `color_set:` set the color of clipper;
- `clip_set:` set clipper of clipper;
- `clip_unset:` unset the clipper of clipper;

Note
  There are other means of assigning parent smart classes to child ones, like the EVAS_SMART_SUBCLASS_NEW macro or the evas_smart_class_inherit_full() function.

References _Evas_Smart_Class::add, _Evas_Smart_Class::calculate, _Evas_Smart_Class::clip_set, _Evas_Smart_Class::clip_unset, _Evas_Smart_Class::color_set, _Evas_Smart_Class::del, _Evas_Smart_Class::hide, _Evas_Smart_Class::member_add, _Evas_Smart_Class::member_del, _Evas_Smart_Class::move, and _Evas_Smart_Class::show.

Referenced by evas_object_smart_clipped_class_get().

const Evas_Smart_Class* evas_object_smart_clipped_class_get | ( | void |  | ) |

Get a pointer to the clipped smart object's class, to use for proper inheritance.

See also
  Clipped Smart Object for more information on this smart class

References evas_object_smart_clipped_smart_set(), and EVAS_SMART_CLASS_INIT_NAME_VERSION.

Evas_Object* evas_object_smart_clipped_clipper_get | ( | const Evas_Object * | obj | ) |

Get the clipper object for the given clipped smart object.

Parameters

  obj | the clipped smart object to retrieve associated clipper from.

Returns
  the clipper object.

Use this function if you want to change any of this clipper's properties, like colors.

See also
  evas_object_smart_clipped_smart_add()

Use this function if you want to change any of this clipper's properties, like colors.